<?php   session_start();
$token = "";
if (isset($_GET['t'])) {
    $token = $_GET['t'];
    $_SESSION['token'] = $_GET['t'];
} else {
    if (!isset($_SESSION['token'])) {
        header("Location: login.php");
    } else {
        $token = $_SESSION['token'];
    }

}
$horaEntrada = false;
$entrada = false;
$salida = false;

$mysqli = new mysqli("db.telcomunity.com", "mifichaje_pro", "S33efbhu?", "");
$fecha = date("y-m-d H:i:s");
$dia = date("d");
$dia = $dia."";


// 1- Saco el identificador del usuario
$sql = "SELECT * FROM mifichaje.login WHERE token = '".$token."' LIMIT 1;";
$resultado = $mysqli->query($sql);
$resultado = $resultado->fetch_array(MYSQLI_ASSOC);
$loginId = $resultado["LOGINID"];
$usuarioEmail = $resultado["LOGIN"];

// 2- Compruebo si existe
$sql = "SELECT * FROM mifichaje.fichaje WHERE LOGINID = ".$loginId." ORDER BY ENTRADA DESC LIMIT 1;";
$resultado = $mysqli->query($sql);

$sql = "SELECT * FROM mifichaje.fichaje WHERE LOGINID = ".$loginId." ORDER BY ENTRADA DESC LIMIT 5;";
$tablas = $mysqli->query($sql);

// 3- Si no hay usuario inserto una entrada
// 3.1- si hay un fichaje asignado al usuario y no tiene salida hacemos un update insertandola
// 3.2-  si hay un fichaje asignado al usuario y ya tiene salida hacemos un update insertandola
if (!$resultado) {
    $salida = true;
} else {
    $resultado = $resultado->fetch_array(MYSQLI_ASSOC);
    if ($resultado["ENTRADA"] == null && $resultado["SALIDA"] == null) {
        $entrada = true;
    }  else if ($resultado["SALIDA"] == null) {
        $salida = true;
    } else {
        $entrada = true;
    }
}

?>
    <?php include 'header.php';?>
<body class=bg-light">

    <div class="container">
        <div class="text-center col-xs-12 col-sm-12 col-md-12 col-lg-10 col-xl-8 mx-auto">
            <img src="img/logo.png" alt="" class="img-fluid">
        </div>

	<div class="row text-center col-xs-12 col-sm-12 col-md-12 col-lg-10 col-xl-8 mx-auto">
            <h3 class="fw-bold">
                <span id="weekDay" class="weekDay"></span>, <span id="day" class="day"></span> de <span id="month" class="month"></span> del <span id="year" class="year"></span>
            </h3>
        </div>

        <div class="row text-center col-xs-12 col-sm-12 col-md-12 col-lg-10 col-xl-8 mx-auto">
            <div class="clock">
                <h2 class="fw-bold"><span id="hours" class="hours"></span>:<span id="minutes" class="minutes"></span>:<span id="seconds" class="seconds"></span></h2>
            </div>
        </div>
        <div class="row text-center col-xs-12 col-sm-12 col-md-12 col-lg-12 col-xl-12 mx-auto">
            <table class="table border" id="tablaRegistros">
                <thead>
                <tr class="table-light">
                    <th scope="col">Dia de la semana</th>
                    <th scope="col">Entrada</th>
                    <th scope="col">Salida</th>
                    <th scope="col">Total</th>
                </tr>
                </thead>
                <tbody >
                <?php
                $totalHoras = 0;
                $totalMinutos = 0;
                while ($fila = $tablas->fetch_row()) {
                    $formato = 'Y-m-d H:i:s';
                    $fecha = DateTime::createFromFormat($formato, $fila[2]);
                    $diasDeLaSemana = array("Domingo","Lunes","Martes","Miércoles","Jueves","Viernes","Sábado");

                    $diaDeLaSemana = $diasDeLaSemana[$fecha->format("w")];
                    $mesActual = $meses[$fecha->format("n")];

                    $horaEntrada = DateTime::createFromFormat('Y-m-d H:i:s', $fila[2]);
                    $horaSalida = DateTime::createFromFormat('Y-m-d H:i:s', $fila[3]);
                    $diferencia = date_diff($horaEntrada, $horaSalida);
                    $dias = $diferencia->d;
                    $horas = $diferencia->h;
                    $minutos = $diferencia->i;

                    if ($dias != null && $dias > 0) {
                        $horas += $dias * 24;
                    }

                    $totalHoras += $horas;
                    $totalMinutos += $minutos;
                    echo
                        '<tr class="">
                    <td class="table-light"><h3>' . $diaDeLaSemana . '</h3></td>
                    <td class="table-light"><h3>'.$fila[2].'</h3></td>
                    <td class="table-success"><h3>'.$fila[3].'</h3></td>
                    <th class="table-danger"><h3>' . $horas.'h '.$minutos . 'min</h3></th>
               </tr>';
                }
                for ($i = 0; $totalMinutos > 60; $i++) {
                    $totalMinutos = $totalMinutos -60;
                    $totalHoras += 1;
                }
                echo
                    '<tr class="">
                    <td class="table-light"></td>
                    <td class="table-light"></td>
                    <td class="table-light"></td>
                    <th class="table-warning">' . $totalHoras.'h '.$totalMinutos . 'min</th>
               </tr>';
                ?>
                </tbody>
            </table>
        </div>
        <div class="row text-center col-xs-12 col-sm-12 col-md-12 col-lg-10 col-xl-8 mx-auto">
            <?php if ($entrada) {
                echo '<button id="entrar" name="entrar" type="button" class="btn btn-outline-success col-6 mx-auto">
                                <i class="bi bi-person-check fs-1" style="font-size: 2rem;"> Entrar</i>
                      </button>';
            };?>
            <?php if ($salida) {
                echo '<button id="salir" name="salir" type="button" class="btn btn-outline-danger col-6 mx-auto">
                                <i class="bi bi-person-x fs-1" style="font-size: 2rem;"> Salir</i>
                        </button>';
            };?>
        </div>
    </div>

</body>

<script>

    // Function to change the content of t2
    function pintarEntrada() {
        console.log("Entroooo");
        var token = "<?php echo $_SESSION['token'];?>";
        var formData = new FormData();
        formData.append('token', token);

        fetch('registrartiempo.php', {
            method: 'POST',
            body: formData
        }).then(function () {
            location.reload();
        });
    }
    function pintarSalida() {
        console.log("Salgooo");
        var token = "<?php echo $_SESSION['token'];?>";
        var formData = new FormData();
        formData.append('token', token);

        fetch('registrartiempo.php', {
            method: 'POST',
            body: formData
        }).then(function () {
            location.reload();
        });

    }

    // Function to add event listener to t
    function entrar() {
        var entrar = document.getElementById("entrar");
        entrar.addEventListener("click", pintarEntrada, false);
    }

    function salir() {
        var salir = document.getElementById("salir");
        salir.addEventListener("click", pintarSalida, false);
    }

    document.addEventListener("DOMContentLoaded", entrar, false);
    document.addEventListener("DOMContentLoaded", salir, false);

    var udateTime = function() {
        let currentDate = new Date(),
            hours = currentDate.getHours(),
            minutes = currentDate.getMinutes(),
            seconds = currentDate.getSeconds(),
            weekDay = currentDate.getDay(),
            day = currentDate.getDate(),
            month = currentDate.getMonth(),
            year = currentDate.getFullYear();

        const weekDays = [
            'Domingo',
            'Lunes',
            'Martes',
            'Miércoles',
            'Jueves',
            'Viernes',
            'Sabado'
        ];

        document.getElementById('weekDay').textContent = weekDays[weekDay];
        document.getElementById('day').textContent = day;

        const months = [
            'Enero',
            'Febrero',
            'Marzo',
            'Abril',
            'Mayo',
            'Junio',
            'Julio',
            'Agosto',
            'Septiembre',
            'Octubre',
            'Noviembre',
            'Diciembre'
        ];

        document.getElementById('month').textContent = months[month];
        document.getElementById('year').textContent = year;

        document.getElementById('hours').textContent = hours;

        if (minutes < 10) {
            minutes = "0" + minutes
        }

        if (seconds < 10) {
            seconds = "0" + seconds
        }

        document.getElementById('minutes').textContent = minutes;
        document.getElementById('seconds').textContent = seconds;
    };

    udateTime();

    setInterval(udateTime, 1000);

</script>
</html>